// comments.js

// Insert a comment div in the middle of a text
function commentText(doc,oNode,action){
	if(oNode!=null){
		if(oNode.nodeType==3){
		  // Get the pattern of the text to comment
      var pattern = getFirstChildTextValue(action,"pattern");
      var reg = getProperRegexp(pattern);
      if(reg!=null){
        // Get a random comment text among those available
        var message = getRandomChildTextValue(action,"message");
        // Search for pattern in node data
  			var oldText = oNode.data;
  			var index = oldText.search(reg);
  			if(index != -1){
  			  // Get the matching text to be commented
  			  var commented = oldText.match(reg);
  				// Trim the text node
  				oNode.replaceData(index,oNode.data.length - index,'');
  				// Create a new div node to wrap everything we will add
  				var divWrapper = doc.createElement('div');
  				divWrapper.setAttribute("style","display:inline;position:relative;");
  				// Define the DIV innerHTML (not very proud of that piece of code)
  				var innerTop = "<a class='info' href='#'" 
            +  "onMouseOver=\"this.childNodes[1].style.display='block';\""
            +  "onMouseOut=\"this.style.backgroundColor='#ccc';this.childNodes[1].style.display='none';\""
            +  "style='background-color:#ccc;color:#000;text-decoration:none;'>";
  				var innerMiddle = "<div style='display: none;position:absolute;top:-1em;left:2em;"
  				  + "z-index:200;width:291px;color:#000;text-align: center;'>"
  				  + "<div style='background-color:#FFF;background:transparent "
            + " url(chrome://kaizou/content/resources/comment-top.png) top left no-repeat;'>"
  				  + "<div style='padding:0.1em 1em;font-weight:normal;padding-left:22px;padding-right:0.5em;background:none;"
            + "text-align:justify;font-family:Verdana,Sans-serif;font-size:12px;white-space:normal;'>";
  				var innerBottom = "</div></div><div style='background:url(chrome://kaizou/content/resources/comment-footer.png) " 
                          + "no-repeat;height:15px;'></div></div></a>";
          // Wrap everything
          divWrapper.innerHTML = innerTop + commented[0] + innerMiddle + message + innerBottom;
  				// If needed, Create a new text node to wrap the end of the text
  				var afterText = oldText.slice(index + commented[0].length,oldText.length);
  				afterTextNode = doc.createTextNode(afterText);
  				// Insert trailing text right after the old one
  				var newNode = oNode.parentNode.insertBefore(afterTextNode,oNode.nextSibling);
  				// Insert the div in the middle
  				oNode.parentNode.insertBefore(divWrapper,newNode);
  			}
			}
		}
	}
}

// Insert a comment anchor in the middle of a text (old version->ugly result)
function commentTextEx(doc,oNode,pattern,message){
	if(oNode!=null){
		if(oNode.nodeType==3){
			var oldText = oNode.data;
			var index = oldText.search(pattern);
			if(index != -1){
				// Trim the text node
				oNode.replaceData(index,oNode.data.length - index,'');
				// Create a new anchor node for the pattern
				aNode = doc.createElement('a');
				patternNode = doc.createTextNode(pattern);
				aNode.appendChild(patternNode);
				aNode.setAttribute('class','info');
				aNode.setAttribute('href','#');
				aNode.setAttribute('onMouseOver',"this.style.backgroundColor='#ff0';this.childNodes[1].style.display='block';");
				aNode.setAttribute('onMouseOut',"this.style.backgroundColor='#ccc';this.childNodes[1].style.display='none';");
				aNode.setAttribute('style','position:relative;z-index:24;background-color:#ccc;color:#000;text-decoration:none;');
    		spanNode = doc.createElement('span');
				spanNode.setAttribute('style','display: none;position:absolute;top:2em;left:2em;width:15em;border:1px solid #0cf;background-color:#cff;color:#000;text-align: center;');
				// Text to be displayed on mouse over
				toolNode = doc.createTextNode(message);
				spanNode.appendChild(toolNode);
				aNode.appendChild(spanNode);
				// If needed, Create a new text node to wrap the end of the text
				var afterText = oldText.slice(index + pattern.length,oldText.length-1);
				afterTextNode = doc.createTextNode(afterText);
				var newNode = oNode.parentNode.insertBefore(afterTextNode,oNode.nextSibling);
				oNode.parentNode.insertBefore(aNode,newNode);
			}
		}
	}
}
